%% Fig. 4A: 


%% Size of Information data
R_cor_vec  = linspace(0,0.98,50);


r_loop = length(R_cor_vec);


Info           = zeros(r_loop,1);
Info_per_spike = zeros(r_loop,1);
max_inf_freq   = zeros(r_loop,1);



%% Constant Parameters

Tau_cor = 10; %(ms)

R_auto = 1;   % For Autocorrelation function this value is always 1

%LIF
ST_threshold = 1; % 

%% Parameters to loop over
%Tau_ratio = 4;

Tau_mem = 20;


thresh_ratio = 1;

ou_sigma = ST_threshold./thresh_ratio;

%% Technical Parameters

%Analytics
ana_tau_min =   -1000; % (ms)
ana_tau_max =    1000; % (ms)
ana_dtau    =    0.5; % (ms)

trunc_n = 20;


%% Assigning taus

 ana_taus  = ana_tau_min:ana_dtau:ana_tau_max;
 disp(['Number of ana_taus: ',...
        num2str(length(ana_taus))]);
    
%% Assigning frequencies for DFT
ana_delta_f = 1/(ana_tau_max-ana_tau_min)*1000;
ana_freqs   = (0:ana_delta_f:(1/ana_dtau*1000/2))/1000;

%% Calculating FiR
FiR = 1/(2*pi*sqrt(Tau_cor*Tau_mem))*exp(-((ST_threshold)^2)...
              /(2*(ou_sigma^2*Tau_cor^2/(2*(Tau_cor+Tau_mem)))));


%% MAIN - Loops over different paramaters
for k = 1:r_loop


R_cor = R_cor_vec(k);   


FiR = 1/(2*pi*sqrt(Tau_cor*Tau_mem))*exp(-((ST_threshold)^2)...
              /(2*(ou_sigma^2*Tau_cor^2/(2*(Tau_cor+Tau_mem)))));

FiR_ana = FiR * 1000;

disp(FiR_ana)



%% Analytic calculation of Autocorrelation function

[autocor_ana, ana_taus_auto]= Cor_analytic(trunc_n,R_auto,ou_sigma,Tau_cor,Tau_mem,...
                               ST_threshold,ST_threshold,ana_taus');


%% Analytic calculation of Crosscorrelation function

crosscor_ana  = Cor_analytic(trunc_n,R_cor,ou_sigma,Tau_cor,Tau_mem,...
                              ST_threshold,ST_threshold,ana_taus');


auto_four_ana  = My_DFT_custom_freqs(ana_taus_auto, autocor_ana', ana_freqs);
auto_four_ana  = real(auto_four_ana);

cross_four_ana = My_DFT_custom_freqs(ana_taus, crosscor_ana', ana_freqs);
cross_four_ana = real(cross_four_ana);

Info_perfreq = -1/2*log2(1-cross_four_ana./(auto_four_ana+1/(ana_tau_max-ana_tau_min)/FiR));

[~, max_inf_freq_index] = max(Info_perfreq(2:end));

max_inf_freq  (k,1) = ana_freqs(max_inf_freq_index+1);
Info          (k,1) = sum(Info_perfreq(2:end),2)*ana_delta_f+Info_perfreq(2)*ana_delta_f;
Info_per_spike(k,1) = Info(k,1)/FiR/1000;




end

%% Fig. 4A
figure,
plot(R_cor_vec,Info,'r','LineWidth',2)
ylim([0 60])