
%% Figure 4B and 4C

%% fOR Fig. 4B choose

% thresh_ratio = 1;


%% For Fig. 4C choose

 thresh_ratio = 0.1;


%% Parameters
Tau_cor = 10; %(ms)

R_cor  = 0.6; % Correlation strength between trials
R_auto = 1;   % For Autocorrelation function this value is always 1

%LIF
ST_threshold = 10; % 

%% Parameters to loop over
Tau_mem_start = 0;
Tau_mem_end   = 2;
Tau_mem_loop  = 50;
Tau_mem_vec = logspace(Tau_mem_start,Tau_mem_end,Tau_mem_loop)+0.001;


ou_sigma = ST_threshold./thresh_ratio;



Info           = zeros(Tau_mem_loop,1);
Info_per_spike = zeros(Tau_mem_loop,1);
max_inf_freq   = zeros(Tau_mem_loop,1);


%% Technical Parameters

%Analytics
ana_tau_min =   -1000; % (ms)
ana_tau_max =    1000; % (ms)
ana_dtau    =    0.5; % (ms)

trunc_n = 20;







%% Assigning taus

 ana_taus  = ana_tau_min:ana_dtau:ana_tau_max;
 disp(['Number of ana_taus: ',...
        num2str(length(ana_taus))]);
    
%% Assigning frequencies for DFT
ana_delta_f = 1/(ana_tau_max-ana_tau_min)*1000;
ana_freqs   = (0:ana_delta_f:(1/ana_dtau*1000/2))/1000;

%% Calculating FiR



%% MAIN - Loops over different paramaters
for k = 1:Tau_mem_loop

Tau_mem = Tau_mem_vec(k);

FiR = 1/(2*pi*sqrt(Tau_cor*Tau_mem))*exp(-((ST_threshold)^2)...
              /(2*(ou_sigma^2*Tau_cor^2/(2*(Tau_cor+Tau_mem)))));

disp(FiR*1000)
%% Analytic calculation of Autocorrelation function

[autocor_ana, ana_taus_auto]= Cor_analytic(trunc_n,R_auto,ou_sigma,Tau_cor,Tau_mem,...
                               ST_threshold,ST_threshold,ana_taus');


%% Analytic calculation of Crosscorrelationfunction

crosscor_ana  = Cor_analytic(trunc_n,R_cor,ou_sigma,Tau_cor,Tau_mem,...
                              ST_threshold,ST_threshold,ana_taus');


auto_four_ana  = My_DFT_custom_freqs(ana_taus_auto, autocor_ana', ana_freqs);
auto_four_ana  = real(auto_four_ana);

cross_four_ana = My_DFT_custom_freqs(ana_taus, crosscor_ana', ana_freqs);
cross_four_ana = real(cross_four_ana);

Info_perfreq = -1/2*log2(1-cross_four_ana./(auto_four_ana+1/(ana_tau_max-ana_tau_min)/FiR));

[~, max_inf_freq_index] = max(Info_perfreq(2:end));

max_inf_freq  (k,1) = ana_freqs(max_inf_freq_index+1);
Info          (k,1) = sum(Info_perfreq(2:end),2)*ana_delta_f+Info_perfreq(2)*ana_delta_f;
Info_per_spike(k,1) = Info(k,1)/FiR/1000;



end


figure,
semilogx(Tau_mem_vec/Tau_cor,Info_per_spike,'r','LineWidth',2)


