
dir_data = dir_name;

cd(dir_data);


Dataset_folders = dir('Dataset*');
Dataset_count = length(Dataset_folders);


for rr = 1:Dataset_count
clearvars -except rr Dataset_folders dir_* Dataset_count
    
    
cd(dir_data)
cd(Dataset_folders(rr).name)    

% Loading parameter from run:
load('params.mat');
load('data.mat')

if(N > 1)
    I_s_signal_u = reshape(I_s_signal_u,1,N*Ntr);
    I_s_noise_u  = reshape(I_s_noise_u ,1,N*Ntr);
end


spike_count = 0;
for x = 1:Ntr
if (~isempty(I_s_signal_u{1,x}))
spike_count = spike_count + size(I_s_signal_u{1,x},2);
end
end

mean_current = 0;
mean_square_current  = 0;
for x = 1:Ntr
    if (~isempty(I_s_signal_u{1,x}))    
mean_current = mean_current + sum(I_s_signal_u{1,x},2);
mean_square_current  = mean_square_current  + sum(I_s_signal_u{1,x}.^2,2);
    end
end
mean_current = mean_current/spike_count;
mean_square_current = mean_square_current/spike_count;
var_current  = mean_square_current - mean_current^2; 
sd_current = sqrt(var_current);


Bin_size = sd_current/200;
Bin_min = mean_current-10*sd_current;
Bin_max = mean_current+10*sd_current;
Bins_Current_signal =  Bin_min:Bin_size:Bin_max;
clear Bin_min Bin_max

tic
hist_I_signal = zeros(Ntr,length(Bins_Current_signal));
for x = 1:Ntr
if (~isempty(I_s_signal_u{1,x}))
Current = I_s_signal_u{1,x};

hist_I_signal(x,:) = histc(Current,Bins_Current_signal);
end
end
toc

P_dist_I_signal = sum(hist_I_signal,1)/spike_count;
p_dist_I_signal = sum(hist_I_signal,1)/spike_count/Bin_size;



spike_count = 0;
for x = 1:Ntr
    if (~isempty(I_s_noise_u{1,x}))
spike_count = spike_count + size(I_s_noise_u{1,x},2);
    end
end

mean_current = 0;
mean_square_current  = 0;
for x = 1:Ntr
    if (~isempty(I_s_noise_u{1,x}))
mean_current = mean_current + sum(I_s_noise_u{1,x},2);
mean_square_current  = mean_square_current  + sum(I_s_noise_u{1,x}.^2,2);
    end
end
mean_current = mean_current/spike_count;
mean_square_current = mean_square_current/spike_count;
var_current  = mean_square_current - mean_current^2; 
sd_current = sqrt(var_current);


Bin_size = sd_current/200;
Bin_min = mean_current-10*sd_current;
Bin_max = mean_current+10*sd_current;
Bins_Current_noise =  Bin_min:Bin_size:Bin_max;
clear Bin_min Bin_max



tic
hist_I_noise = zeros(Ntr,length(Bins_Current_noise));
for x = 1:Ntr
if (~isempty(I_s_noise_u{1,x}))
Current = I_s_noise_u{1,x};
hist_I_noise(x,:) = histc(Current,Bins_Current_noise);
end
end
toc

P_dist_I_noise = sum(hist_I_noise,1)/spike_count;            % P -> Probability distribution
p_dist_I_noise = sum(hist_I_noise,1)/spike_count/Bin_size;   % p -> Probability DENSITY 



fig = figure;
bar(Bins_Current_signal, p_dist_I_signal,'BarWidth',1);
hold on
bar(Bins_Current_noise, p_dist_I_noise,'BarWidth',1);
gauss = 1/sqrt(2*pi*var_current)*exp(-(Bins_Current_noise-mean_current).^2/(2*var_current));
plot(Bins_Current_noise, gauss,'black')


save('p_dist.mat', 'P_dist_I*', 'Bins_Current*');
savefig(fig,'p_dist_I_spike')

close all

end
