%% Choose Data

tic_start = tic;

 
cd (dir_data);
 
 
Dataset_folders = dir('Dataset*');
Dataset_count = length(Dataset_folders);




for rr = 1:Dataset_count
clearvars -except dir_* Dataset_* tic* rr
    
    
tic_rr = tic;

cd(dir_data);
cd(Dataset_folders(rr,1).name)



bin_count_max = 10000;% ms
bin_count_min = 10; % ms
scan_count= 50; % number of different bincounts scanned

bin_count_for_info = 5000;

bin_count_scan = linspace(bin_count_min,bin_count_max,scan_count);


    

% Loading parameter from run:
load('params_ISI.mat');
load('first_spike_matrix.mat');


%% Dynamic binning

FiR_u = 1/mean(mean(t_s_fs_matrix_u,2),1)*1000;
FiR_r = 1/mean(mean(t_s_fs_matrix_r,2),1)*1000;

ISI_mean_u = mean(t_s_fs_matrix_u(:));
ISI_std_u = std(t_s_fs_matrix_u(:));
ISI_upper_std_factor = 10;
ISI_t_min   = 0;
ISI_t_max   = ISI_mean_u + ISI_upper_std_factor*ISI_std_u; % Maximum ISI set to mean_ISI plus 15 times the standard deviation of ISI


ISI_delta_t_scan = zeros(scan_count,1);
Entropy_u_scan   = zeros(scan_count,1);
Entropy_r_scan   = zeros(scan_count,1);
MI_ISI_pt_scan   = zeros(scan_count,1);


for xx= 1:scan_count
ISI_bin_count = bin_count_scan(xx);
ISI_t       = linspace(ISI_t_min,ISI_t_max,ISI_bin_count);
ISI_delta_t = ISI_t(2)-ISI_t(1);

ISI_delta_t_scan(xx)= ISI_delta_t;

plot_ISI_t  = repmat(ISI_t,N,1);


bin_count   = length(ISI_t);

hist_u    = zeros(N,bin_count);
hist_r    = zeros(N,bin_count);






parfor x = 1:N

spike_times = t_s_fs_matrix_u(x,:);
hist_u(x,:) = histc(spike_times,ISI_t);

end
clear t_s_u




parfor x = 1:N
    
spike_times = t_s_fs_matrix_r(x,:);
hist_r(x,:) = histc(spike_times,ISI_t);

end
clear t_s_r

ISI_count_u = sum(hist_u,2);
ISI_count_r = sum(hist_r,2);


p_ISI_u   = bsxfun(@rdivide,hist_u,ISI_count_u);
p_ISI_r   = bsxfun(@rdivide,hist_r,ISI_count_r);

iszero_u = p_ISI_u==0;
iszero_r = p_ISI_r==0;
%% Version 1

Entropy_per_bin_u = -p_ISI_u.*log2(p_ISI_u);
Entropy_per_bin_r = -p_ISI_r.*log2(p_ISI_r);



Entropy_per_bin_u(iszero_u) = 0;
Entropy_per_bin_r(iszero_r) = 0;

Entropy_u = mean(sum(Entropy_per_bin_u,2),1);
Entropy_r = mean(sum(Entropy_per_bin_r,2),1);

Info = Entropy_u - Entropy_r;




Entropy_u_scan(xx) = Entropy_u*FiR_fs_mean_u;
Entropy_r_scan(xx) = Entropy_r*FiR_fs_mean_u;
MI_ISI_pt_scan(xx) = Info*FiR_fs_mean_u;


disp(['Scan ',num2str(xx),' of ',num2str(scan_count),' done.']);
 
end

index = find(bin_count_scan>bin_count_for_info,1);

bin_count_for_result = bin_count_scan(index);
MI_ISI_pt            = MI_ISI_pt_scan(index);


scan_time = toc(tic_rr);

disp(['Full Scan of Dataset ',num2str(rr),' complete!! Time was ',num2str(scan_time),' seconds.'])

save('bin_count_scan.mat','ISI_upper_std_factor','Entropy_u_scan','Entropy_r_scan','MI_ISI_pt*','ISI_delta_t_scan', 'bin_count_scan','scan_time')

fig1 = figure;
hold on
plot(bin_count_scan,Entropy_u_scan,'--bo')
plot(bin_count_scan,Entropy_r_scan,'--r+')
plot(bin_count_scan,MI_ISI_pt_scan,'-')
ylabel('Entropy/Information rate [bit/s]')
xlabel('Bin Count')
savefig(fig1,'bin_count_scan.fig')


fig2 = figure;

semilogx(1./bin_count_scan,Entropy_u_scan,'--bo')
hold on
semilogx(1./bin_count_scan,Entropy_r_scan,'--r+')
semilogx(1./bin_count_scan,MI_ISI_pt_scan,'-')
line([1/bin_count_for_result 1/bin_count_for_result],[0 500])
ylabel('Entropy/Information rate [bit/s]')
xlabel('Inverse Bin Count')
savefig(fig2,'bin_count_scan_inverse.fig')
close all

end
