
dir_return = pwd;

%% Corr

f_name = 'Corr_Readout.mat';

 dir_data_Corr = [dir_return,'/Simulation_Data/Corr'];

cd(dir_data_Corr);

Dataset_folders = dir('Dataset*');
Dataset_count   = length(Dataset_folders);

plot_ou_Tau_Corr  = zeros(Dataset_count,1);
plot_FiR_Corr     = zeros(Dataset_count,1);
plot_Info_Corr    = zeros(Dataset_count,1);
plot_Info_Corr_ps = zeros(Dataset_count,1);
plot_Info_PSTH_num = zeros(Dataset_count,1);
plot_2ISI_corr = zeros(Dataset_count,1);

for rr = 1:Dataset_count
    

    
cd(dir_data_Corr);


cd(Dataset_folders(rr,1).name)

load('params.mat','ou_Tau_cor')
plot_ou_Tau_Corr(rr) = ou_Tau_cor;
load('data.mat','FiR_u_mean')
plot_FiR_Corr(rr)   = FiR_u_mean*1000; % Firing rate in Hz
    
load('correlation_2ISI.mat','corr_2ISI') 
plot_2ISI_corr(rr) = corr_2ISI;


loadname = f_name;
load(loadname,'Info_pn_cor2','num_delta_f','FiR_u_mean')

plot_Info_Corr(rr) = sum(mean(Info_pn_cor2(:,2:end),1),2)*num_delta_f...
                     + mean(Info_pn_cor2(:,2),1)*num_delta_f;

plot_Info_Corr_ps(rr) = plot_Info_Corr(rr)/plot_FiR_Corr(rr);


load('PSTH_numeric.mat','Info_PSTH_corrected')

plot_Info_PSTH_num(rr) = Info_PSTH_corrected;


end

% Sorting according to ou_Taus
[plot_ou_Tau_Corr, sort_matrix] = sort(plot_ou_Tau_Corr);

plot_FiR_Corr     = plot_FiR_Corr(sort_matrix);
plot_Info_Corr    = plot_Info_Corr(sort_matrix);
plot_Info_Corr_ps = plot_Info_Corr_ps(sort_matrix);
plot_Info_PSTH_num    = plot_Info_PSTH_num(sort_matrix);
plot_2ISI_corr    = plot_2ISI_corr(sort_matrix);


%% ISI- Data

f_name = 'bin_count_scan.mat';
dir_data_ISI = [dir_return,'/Simulation_Data/ISI'];
cd(dir_data_ISI);

Dataset_folders = dir('Dataset*');


Dataset_count = length(Dataset_folders);


plot_Info_ISI = zeros(Dataset_count,1);
plot_ou_Tau_ISI   = zeros(Dataset_count,1);

for rr = 1:Dataset_count
    
cd(dir_data_ISI);

cd(Dataset_folders(rr,1).name)


if(exist(f_name,'file'))
load(f_name,'MI_ISI_pt');
plot_Info_ISI(rr,1) = MI_ISI_pt;

% ou_Tau
load('params.mat','ou_Tau_cor');
plot_ou_Tau_ISI(rr,1) = ou_Tau_cor;
else
    plot_Info_ISI(rr,1) = NaN;
    plot_ou_Tau_ISI(rr,1) = NaN;
end

end
% Sorting according to ou_Taus
[plot_ou_Tau_ISI, sort_matrix] = sort(plot_ou_Tau_ISI);

plot_Info_ISI = plot_Info_ISI(sort_matrix);

%% Plotting

h = figure; hold on;


plot(plot_ou_Tau_ISI ,plot_Info_ISI, '--o','LineWidth',2,'MarkerSize',10,'Color',[0 0 0])
plot(plot_ou_Tau_Corr,plot_Info_Corr,'--o','LineWidth',2,'MarkerSize',10,'Color',[0 0 1])
plot(plot_ou_Tau_Corr,plot_Info_PSTH_num,'--o' ,'LineWidth',2,'MarkerSize',10,'Color',[1 0 0])

% Please note that for numerical reasons the variable plot_Info_Corr can
% have a negligibly small imaginary component, e.g. 0.0000000, because the
% autocorrelation function of the PSTH (c_cross) has a small residual
% asymetry. An autocorrelation function should mathematically be
% symetrical around zero, but whenever both sides -tau and +tau are
% calculated separately, there may be small numerical deviations that lead
% to this residual imaginary component which is multiple orders of
% magnitude smaller than the real value and can safely be neglected.

xlabel('Tau_{Stim} (ms)','Fontsize',16);
ylabel('Information rate (bit/s)','Fontsize',16)

yyaxis right
plot(plot_ou_Tau_Corr,plot_2ISI_corr,'-.^','LineWidth',2,'MarkerSize',10)
ylim([0 0.1])
ylabel('Correlation Coefficient','Fontsize',16)

% plot options
xlim([0.2 200]);
%ylim([0 20]);
set(gca,'fontsize',16)

