%% Choose Data

tic_total = tic;

dir_data = [dir_name_base, 'Corr'];

cd(dir_data);

Dataset_folders = dir('Dataset*');
Dataset_count = length(Dataset_folders);





for rrr= 1:Dataset_count 
clearvars -except rrr Dataset_folders dir_* Dataset_count  tic*

rr = Dataset_count - rrr +1;

cd(dir_data)
cd(Dataset_folders(rr).name)
    
   
   
% Loading parameter from run:
load('params.mat');
load('data.mat')

tic_dataset = tic;

%% Parameter




% Params Corfunctions
num_tau_min = -500; % (ms)
num_tau_max =  500; % (ms)
num_dtau    = 1;   % (ms)

cor_sigma   = 0.1;%max([0.1,dt]); % (ms) sigma for calculating the correlation function. This
                   %      is the sigma of the gaussian probability density
                   %      function.

                   
% Params Analytic
ana_tau_min = -500; % (ms)
ana_tau_max =  500; % (ms)
ana_dtau    =  1; % (ms)

trunc_n = 60;

R_auto = 1;
if(~exist('ou_cor_r','var'))
ou_cor_r=0.8;
display('Careful: ou_cor_r was not defined!!!')
end
if(~exist('ou_sigma','var'))
ou_sigma= 1;
display('Careful: ou_cor_r was not defined!!!')
end

R_cor  = ou_cor_r;

            
                
freq_max = 500; % Max frequency to evaluate (Hz)

delta_f = 1;



%% Assigning vectors
freqs = 0:delta_f:freq_max;
 
Nf = length(freqs); % number of frequencies
 
num_delta_f = 1/(num_tau_max-num_tau_min)*1000;
num_freqs   = (0:num_delta_f:(1/num_dtau*1000/2))/1000;
 
ana_delta_f = 1/(ana_tau_max-ana_tau_min)*1000;
ana_freqs   = (0:ana_delta_f:(1/ana_dtau*1000/2))/1000;
 
disp(['Number of frequencies: ',...
        num2str(Nf)]);
    
num_taus  = num_tau_min:num_dtau:num_tau_max;
disp(['Number of num_taus: ',num2str(length(num_taus))]);
    
ana_taus  = ana_tau_min:ana_dtau:ana_tau_max;
disp(['Number of ana_taus: ',num2str(length(ana_taus))]);




%% Analytic calculations
if(exist('EIF_Tau','var'))
LI_Tau_mem = EIF_Tau;
end

LI_Tau_mem = LI_Tau_mem+0.01;

% Autocorrelation
[autocor_ana, ana_taus_auto] = Cor_analytic(trunc_n,R_auto,ou_sigma,ou_Tau_cor,LI_Tau_mem,...
                               ST_threshold,ST_threshold,ana_taus');
% Crosscorrelation
[crosscor_ana, ~ ]           = Cor_analytic(trunc_n,R_cor,ou_sigma,ou_Tau_cor,LI_Tau_mem,...
                               ST_threshold,ST_threshold,ana_taus');
LI_Tau_mem = LI_Tau_mem-0.01;
                           
% Fourier Transform
auto_four_ana  = My_DFT_custom_freqs(ana_taus_auto, autocor_ana', ana_freqs);
auto_four_ana  = real(auto_four_ana);

cross_four_ana = My_DFT_custom_freqs(ana_taus, crosscor_ana', ana_freqs);
cross_four_ana = real(cross_four_ana);


Info_ana = -1/2*log2(1-cross_four_ana./(auto_four_ana+1/(ana_tau_max-ana_tau_min)/FiR_analytic));




%% Help functions


Off_Fac_num_u = 1/(num_tau_max-num_tau_min)*FiR_u_mean*T_seq_korrigiert; 
%% Assigning vectors

% Correlation functions
autocor_num_u  = zeros(N,length(num_taus));
crosscor_num_r = zeros(N,length(num_taus));

% Fouriertransforms of correlation functions
auto_four_u  = zeros(N,length(num_freqs));
cross_four_r = zeros(N,length(num_freqs));

% Information
Info_pn_cor2  = zeros(N,length(num_freqs));


parfor pp = 1:N

tic_pp = tic;



    
%% Correlation functions
tic_corr = tic;

% Autocorrelation
autocor_num_u(pp,:)  = Autocor_numeric_If_empty (num_taus,cor_sigma,t_s_u{pp}');
% Crosscorrelation
crosscor_num_r(pp,:) = Crosscor_numeric_If_empty(num_taus,cor_sigma,t_s_r{pp}');



%% Fouriertranformations

tic_four = tic;

%  Numeric functions
auto_four_u_temp   = real(My_DFT_custom_freqs(num_taus, autocor_num_u(pp,:), num_freqs)); %% HIER AUFPASSEN OB Matrix trans genommen werden muss oder nicht
auto_four_u(pp,:)  = real(auto_four_u_temp);

cross_four_r_temp  = My_DFT_custom_freqs(num_taus, crosscor_num_r(pp,:), num_freqs);
cross_four_r(pp,:) = real(cross_four_r_temp);



%% Information calculations 

Info_pn_cor2(pp,:)  = -1/2*log2(1-cross_four_r(pp,:)./(auto_four_u(pp,:)+Off_Fac_num_u)); % Hier repeaats

disp(strcat(['Stimulus ', num2str(pp),' of ', num2str(N),' done. Time was ',num2str(toc(tic_pp)), ' seconds.']));  

end
%% Save

sim_time_dataset = toc(tic_dataset);


clear t_s_*


savename_mat = 'Corr_Readout';
savename_fig = 'Corr_Readout';

save([savename_mat,'.mat']);

disp(['Total simulation time is ',num2str(sim_time_dataset),' seconds.']);


%% Plots for paper


fig2 = figure;
subplot(2,2,1)
plot(num_taus,mean(autocor_num_u,1)/T_seq_korrigiert/FiR_u_mean^2)
hold on
plot(ana_taus_auto,autocor_ana,'r')
xlim([-500 500]);
ylim([0 2]);
xlabel('\{Tau} (ms)')
ylabel('Correlation (Hz)')

subplot(2,2,2)
plot(num_taus,mean(crosscor_num_r,1)/T_seq_korrigiert/FiR_r_mean^2)
hold on
plot(ana_taus,crosscor_ana,'r')
xlim([-500 500]);
ylim([0 5]);
xlabel('\{Tau} (ms)')
ylabel('Correlation (Hz)')


plot_res = 1;

subplot(2,2,3)
plot(num_freqs(2:plot_res:end)*1000,mean(Info_pn_cor2(:,2:plot_res:end),1),'b+')
hold on
plot(ana_freqs(2:end)*1000, mean(Info_ana(:,2:end),1),'r')
xlim([0 500])
ylim([0 0.2]);
xlabel('Frequency (Hz)')
ylabel('Information (bit/(Hz*s))')

savefig(fig2,savename_fig)
end

