%% Choose Data


tic_total = tic;

dir_data = [dir_name_base, 'Strong'];

cd(dir_data);


Dataset_folders = dir('Dataset*');

Dataset_count = length(Dataset_folders);


for rr = 1:Dataset_count

tic_rr = tic;

cd(dir_data);
cd(Dataset_folders(rr,1).name)

load('params.mat', 'N', 'Ntr', 'T_seq_korrigiert', 'LI_Tau_mem');

%% Parameter


if LI_Tau_mem<99

dig_bin_size = 2; %ms

else
    
  dig_bin_size = 12; %ms  
  
end



T_window_start = 5*dig_bin_size;
T_window_end   = 20*dig_bin_size;
T_window_count = 5;



hord_limit = 30;



%% Original Strong method
T_window_inverse = linspace(1/T_window_start,1/T_window_end,T_window_count);
T_window = 1./T_window_inverse;



MI_pt_Strong = zeros(T_window_count,1) ;
Entropy_pt_u = zeros(T_window_count,1) ;
Entropy_pt_r = zeros(T_window_count,1) ;



%% Loading
tic_loading = tic;
load('data.mat', 't_s_u');
load('data.mat', 't_s_r');


disp(['LOADING: Time spent was ', num2str(toc(tic_loading)), ' seconds!'])


for pp = 1:T_window_count

T_short = T_window(pp);

dig_bins = 0:dig_bin_size:T_short;
dig_bc = length(dig_bins);


tic_window = tic;
    
%% Uniques

%% Shortening Spiketrains

t_s_u_short = cell(N,Ntr);

for i = 1:N
for j = 1:Ntr
  t_s_u_short{i,j} = t_s_u{i}{j}(t_s_u{i}{j}<= T_short); 
 end
end




%% Entropy calculation

Entropy_uniques0 = zeros(N,1);
Entropy_uniques1 = zeros(N,1);
Entropy_uniquesh = zeros(N,hord_limit-1);

non_unique_ratio_u = zeros(N,1);


Spike_counts_uniques = zeros(N,Ntr);
parfor i = 1:N


%% Calculating Firing Rates
Spike_counts_u = zeros(1,Ntr); 

for j = 1:Ntr
   Spike_counts_u(1,j) = length(t_s_u_short{i,j});
end

Spike_counts_uniques(i,:) = Spike_counts_u;

%% Digitalizing the spiketrain



dig_st_u = false(Ntr,dig_bc);

non_unique_bins_u = zeros(Ntr,1);

for j = find(Spike_counts_u)
    true_spikes = ceil(t_s_u_short{i,j}./dig_bin_size);
    dig_st_u(j,true_spikes) = true;
    
    non_unique_bins_u(j) = length(true_spikes)-length(unique(true_spikes));
end

mean_non_unique_bins_u = mean(non_unique_bins_u);
non_unique_ratio_u(i,1) = mean_non_unique_bins_u/mean(Spike_counts_u);



%% Entropy for zero spikes
p_ord0_u = size(dig_st_u(Spike_counts_u == 0,:),1)/Ntr;
p_ord0_u = p_ord0_u(logical(p_ord0_u));
Entropy_ord0_u = -sum(p_ord0_u.*log2(p_ord0_u));

%% Entropy for the single spike spiketrains
p_ord1_u = sum(dig_st_u(Spike_counts_u == 1,:),1)/Ntr;
p_ord1_u = p_ord1_u(logical(p_ord1_u));
Entropy_ord1_u = -sum(p_ord1_u.*log2(p_ord1_u));


tic_hord_u = tic;
%% Higher order - Method 1
Entropy_hord_u = zeros(hord_limit-1,1);

for order = 2:hord_limit


hord = order; % hord = higher order
dig_st_hord =  dig_st_u(Spike_counts_u == hord,:);



st_case_u = 1;
st_case_count_u = [];
while(~isempty(dig_st_hord))
    
    
    y_n = false(size(dig_st_hord,1),1);
    
    for m = 1:size(dig_st_hord,1)
        y_n(m,1) = isequal(dig_st_hord(1,:), dig_st_hord(m,:));
        
    end
    
    dig_st_hord = dig_st_hord(~y_n,:);
    st_case_count_u(st_case_u,1) = sum(y_n,1);
    
    st_case_u = st_case_u+1;
end


p_hord_u = st_case_count_u./Ntr;
Entropy_hord_u(hord-1,1) = -sum(p_hord_u.*log2(p_hord_u));
end

Entropy_uniques0(i,1) = Entropy_ord0_u;
Entropy_uniques1(i,1) = Entropy_ord1_u;
Entropy_uniquesh(i,:) = Entropy_hord_u;

toc_hord_u = toc(tic_hord_u);


end





%% Repeats


%% Shortening Spiketrains
t_s_r_short = cell(N,Ntr);

for i = 1:N
for j = 1:Ntr
  t_s_r_short{i,j} = t_s_r{i}{j}(t_s_r{i}{j}<= T_short);
 end
end

%clear t_s_r;
%% Entropy calculation

Entropy_repeats0 = zeros(N,1);
Entropy_repeats1 = zeros(N,1);
Entropy_repeatsh = zeros(N,hord_limit-1);

non_unique_ratio_r = zeros(N,1);

Spike_counts_repeats = zeros(N,Ntr);

parfor i = 1:N


%% Calculating Firing Rates
Spike_counts_r = zeros(1,Ntr); 

for j = 1:Ntr
   Spike_counts_r(1,j) = length(t_s_r_short{i,j});
end

Spike_counts_repeats(i,:) = Spike_counts_r;

%% Digitalizing the spiketrain

dig_st_r = false(Ntr,dig_bc);

non_unique_bins_r = zeros(Ntr,1);

for j = find(Spike_counts_r)
    true_spikes = ceil(t_s_r_short{i,j}./dig_bin_size);
    dig_st_r(j,true_spikes) = true;
    
    non_unique_bins_r(j) = length(true_spikes)-length(unique(true_spikes));
end

mean_non_unique_bins_r = mean(non_unique_bins_r);
non_unique_ratio_r(i,1) = mean_non_unique_bins_r/mean(Spike_counts_r);



%% Entropy for zero spikes
p_ord0_r = size(dig_st_r(Spike_counts_r == 0,:),1)/Ntr;
p_ord0_r = p_ord0_r(logical(p_ord0_r));
Entropy_ord0_r = -sum(p_ord0_r.*log2(p_ord0_r));

%% Entropy for the single spike spiketrains
p_ord1_r = sum(dig_st_r(Spike_counts_r == 1,:),1)/Ntr;
p_ord1_r = p_ord1_r(logical(p_ord1_r));
Entropy_ord1_r = -sum(p_ord1_r.*log2(p_ord1_r));


tic_hord_r = tic;
%% Higher order - Method 1
Entropy_hord_r = zeros(hord_limit-1,1);

for order = 2:hord_limit


hord = order; % hord = higher order
dig_st_hord =  dig_st_r(Spike_counts_r == hord,:);

st_case_r = 1;
st_case_count_r = [];
while(~isempty(dig_st_hord))
    
    
   
    y_n = false(size(dig_st_hord,1),1);
    
    for m = 1:size(dig_st_hord,1)
        y_n(m,1) = isequal(dig_st_hord(1,:), dig_st_hord(m,:));
        
    end
    
    dig_st_hord = dig_st_hord(~y_n,:);
    st_case_count_r(st_case_r,1) = sum(y_n,1);
    
    st_case_r = st_case_r+1;
end

p_hord_r = st_case_count_r./Ntr;
Entropy_hord_r(hord-1,1) = -sum(p_hord_r.*log2(p_hord_r));
end

Entropy_repeats0(i,1) = Entropy_ord0_r;
Entropy_repeats1(i,1) = Entropy_ord1_r;
Entropy_repeatsh(i,:) = Entropy_hord_r;

toc_hord_r = toc(tic_hord_r);

end

%% Mutual Information

Entropy_uniques = zeros(N,hord_limit+1);
Entropy_repeats = zeros(N,hord_limit+1);

Entropy_uniques(:,1)     = Entropy_uniques0;
Entropy_uniques(:,2)     = Entropy_uniques1;
Entropy_uniques(:,3:end) = Entropy_uniquesh;

Entropy_repeats(:,1)     = Entropy_repeats0;
Entropy_repeats(:,2)     = Entropy_repeats1;
Entropy_repeats(:,3:end) = Entropy_repeatsh;



MI_phord_pn_Strong = Entropy_uniques - Entropy_repeats;

MI_phord_Strong = mean(MI_phord_pn_Strong,1);

MI_Strong= sum(MI_phord_Strong,2);

MI_pt_Strong(pp) = MI_Strong/T_short*1000;

Entropy_pt_u(pp) = mean(sum(Entropy_uniques,2),1)/T_short*1000;
Entropy_pt_r(pp) = mean(sum(Entropy_repeats,2),1)/T_short*1000;

disp(['WINDOW DONE: ', num2str(pp), ' of ', num2str(T_window_count), ' !'])
disp(['WINDOW DONE: Time spent was ', num2str(toc(tic_window)), ' seconds!'])
end


%% Plots
plot_end = length(T_window);


h = figure;
plot(1000*1./T_window(1:plot_end),Entropy_pt_u(1:plot_end));
hold on
plot(1000*1./T_window(1:plot_end),Entropy_pt_r(1:plot_end),'red');
plot(1000*1./T_window(1:plot_end),MI_pt_Strong(1:plot_end),'green');

hold on
plot(1000*1./T_window(1:plot_end),Entropy_pt_u(1:plot_end),'o');
hold on
plot(1000*1./T_window(1:plot_end),Entropy_pt_r(1:plot_end),'ro');
plot(1000*1./T_window(1:plot_end),MI_pt_Strong(1:plot_end),'go');

xlim([0 1/T_window(1)*1000])
ylim([0 1.2*max(Entropy_pt_u)])


%% Fit
fit_end = 3;


modelFun = @(coefs,x) coefs(1)+coefs(2)*x;
startingVals = [20 -0.1];

xfit = 1000*T_window_inverse(1:fit_end);
yfit = MI_pt_Strong(1:fit_end)';

coefsEsts = nlinfit(xfit,yfit, modelFun, startingVals);
x_fit = linspace(0,1000*T_window_inverse(1),200);
y_fit = modelFun(coefsEsts, x_fit);


savename_fig = ['Strong_readout','.fig'];
savename_mat = ['Strong_readout','.mat'];

hold on
line(x_fit, y_fit, 'Color', 'black');
saveas(h,savename_fig);
close all


sim_time_dataset = toc(tic_rr);

%% Save

save(savename_mat,'Entropy*','MI*','T_window','T_window_inverse', 'Spike_counts*',...
     'non_unique_ratio_*','hord_limit','dig_bin_size','x_fit','y_fit','fit_end','sim_time_dataset')

 
 
disp(strcat(['Dataset ', num2str(rr),' of ', num2str(Dataset_count),' done. Time was ',num2str(sim_time_dataset), ' seconds.']));   

clearvars -except Dataset_folders rr Dataset_count dir_* tic*
 


end
