
dir_return = pwd;



f_name = 'Corr_Readout.mat';



dir_data_Corr = [dir_return,'/Simulation_Data/Corr'];
    
cd(dir_data_Corr);

Dataset_folders = dir('Dataset*');
Dataset_count   = length(Dataset_folders);




plot_Tau_Corr     = zeros(Dataset_count,1);
plot_FiR_Corr     = zeros(Dataset_count,1);
plot_Info_Corr    = zeros(Dataset_count,1);
plot_Info_Corr_ps = zeros(Dataset_count,1);


for rr = 1:Dataset_count
    

    
cd(dir_data_Corr);

cd(Dataset_folders(rr,1).name)

load('params.mat','LI_Tau_mem')
plot_Tau_Corr(rr,1) = LI_Tau_mem;
load('data.mat','FiR_u_mean')
plot_FiR_Corr(rr,1)   = FiR_u_mean*1000;
    
  


if(exist(f_name))
loadname = f_name;
load(loadname,'Info_pn_cor2','num_delta_f','FiR_u_mean')

plot_Info_Corr(rr,1) = sum(mean(Info_pn_cor2(:,2:end),1),2)*num_delta_f...
                     + mean(Info_pn_cor2(:,2),1)*num_delta_f;

plot_Info_Corr_ps(rr,1) = plot_Info_Corr(rr,1)/plot_FiR_Corr(rr,1);
else
plot_Info_Corr(rr,1)    = NaN;
plot_Info_Corr_ps(rr,1) = NaN;
end
end



 

f_name = 'Strong_readout.mat';

dir_data_Strong = [dir_return,'/Simulation_Data/Strong'];
    
cd(dir_data_Strong);

Dataset_folders = dir('Dataset*');
Dataset_count   = length(Dataset_folders);




plot_Tau_Strong     = zeros(Dataset_count,1);
plot_FiR_Strong     = zeros(Dataset_count,1);
plot_Info_Strong    = zeros(Dataset_count,1);
plot_Info_Strong_ps = zeros(Dataset_count,1);

for rr = 1:Dataset_count


    
cd(dir_data_Strong);

cd(Dataset_folders(rr,1).name)

loadname = f_name;


load('params.mat','LI_Tau_mem')
plot_Tau_Strong(rr,1) = LI_Tau_mem;
load('data.mat','FiR_u_mean')
plot_FiR_Strong(rr,1) = FiR_u_mean*1000;


load(loadname, 'y_fit')

plot_Info_Strong(rr,1)    = y_fit(1); 
plot_Info_Strong_ps(rr,1) = y_fit(1)/plot_FiR_Strong(rr,1); 


end



figd = figure;
set(gca,'FontSize',16)
hold on


semilogx(plot_Tau_Corr(:,1),plot_Info_Corr(:,1),'bs','LineWidth',2,'MarkerSize',12)
hold on
% Please note that for numerical reasons the variable plot_Info_Corr can
% have a negligibly small imaginary component, e.g. 0.0000000, because the
% autocorrelation function of the PSTH (c_cross) has a small residual
% asymetry. An autocorrelation function should mathematically be
% symetrical around zero, but whenever both sides -tau and +tau are
% calculated separately, there may be small numerical deviations that lead
% to this residual imaginary component which is multiple orders of
% magnitude smaller than the real value and can safely be neglected.

semilogx(plot_Tau_Strong(:,1),plot_Info_Strong(:,1),'black^','LineWidth',2,'MarkerSize',12)
xlim([3 100]);
title('Information Rate')
xlabel('Membrane Time Constant\tau_{mem} [s]','FontSize',16)
ylabel('Information Rate [bit/(Hz \cdot s)]','FontSize',16)

