
%% Properties


plot_freq   = 9; %Hz

dir_data = [dir_name, 'Input_Switch10Hz'];

cd(dir_data);

 load('params.mat','T_seq_korrigiert','Ntr')

%% Specify Frequencies

freqs_deltaf = 1/T_seq_korrigiert*1000;
freq         = ceil(plot_freq/freqs_deltaf)*freqs_deltaf;

%% Uniques
%% Calculate sine and cosine coefficients


 load('data.mat','t_s_u')
t_s = t_s_u;



coef_complex_u = zeros(Ntr,1);

coef_cos_u = zeros(Ntr,1);
coef_sin_u = zeros(Ntr,1);

parfor i = 1 : Ntr 


   coef_complex_u(i,1) = 1000*2/T_seq_korrigiert*sum(exp(1i*2*pi*freq*t_s{1,i}/1000),2)';
   coef_cos_u(i,1)     = 1000*2/T_seq_korrigiert*sum(cos(2*pi*freq*t_s{1,i}/1000),2)';
   coef_sin_u(i,1)     = 1000*2/T_seq_korrigiert*sum(sin(2*pi*freq*t_s{1,i}/1000),2)';

end



%% Further calculation


var_cos_u = var(coef_cos_u(:,1));
var_sin_u = var(coef_sin_u(:,1));


mean_cos_u = mean(coef_cos_u(:,1));
mean_sin_u = mean(coef_sin_u(:,1));


coef_abs_u   = sqrt((coef_cos_u-mean_cos_u).^2+(coef_sin_u-mean_sin_u).^2);
coef_angle_u = atan2(coef_sin_u-mean_sin_u,coef_cos_u-mean_cos_u);%atan((coef_sin_u-mean_sin_u)./(coef_cos_u-mean_cos_u));


coef_angle_nn_u = atan((coef_sin_u)./(coef_cos_u));





%% Repeats
%% Calculate sine and cosine coefficients


 load('data.mat','t_s_r')
t_s = t_s_r;



coef_complex_r = zeros(Ntr,1);

coef_cos_r = zeros(Ntr,1);
coef_sin_r = zeros(Ntr,1);

parfor i = 1 : Ntr 


   coef_complex_r(i,1) = 1000*2/T_seq_korrigiert*sum(exp(1i*2*pi*freq*t_s{1,i}/1000),2)';
   coef_cos_r(i,1)     = 1000*2/T_seq_korrigiert*sum(cos(2*pi*freq*t_s{1,i}/1000),2)';
   coef_sin_r(i,1)     = 1000*2/T_seq_korrigiert*sum(sin(2*pi*freq*t_s{1,i}/1000),2)';

end



%% Further calculation

var_cos_r = var(coef_cos_r(:,1));
var_sin_r = var(coef_sin_r(:,1));


mean_cos_r = mean(coef_cos_r(:,1));
mean_sin_r = mean(coef_sin_r(:,1));


coef_abs_r   = sqrt((coef_cos_r-mean_cos_r).^2+(coef_sin_r-mean_sin_r).^2);
coef_angle_r = atan2(coef_sin_r-mean_sin_r,coef_cos_r-mean_cos_r);%atan((coef_sin_r-mean_sin_r)./(coef_cos_r-mean_cos_r));



%% Plotting cos

bins_min = -4;
bins_max =  4;
bins_count =30; 
bins_cos_u = linspace(bins_min,bins_max,bins_count);
bins_delta_cos_u = bins_cos_u(2)-bins_cos_u(1);

coef_count = size(coef_cos_u,1);
hist_cos_u = histc(coef_cos_u,bins_cos_u)/coef_count/bins_delta_cos_u;



bins_cos_r = bins_cos_u;
bins_delta_cos_r = bins_cos_r(2)-bins_cos_r(1);

coef_count = size(coef_cos_r,1);
hist_cos_r = histc(coef_cos_r,bins_cos_r)/coef_count/bins_delta_cos_r;

norm_x_count = 10000;
norm_x = linspace(min([bins_cos_u(1) bins_cos_r(1)]),20,norm_x_count);

norm_dis_cos_u = 1/sqrt(2*pi*var_cos_u)*exp(-(norm_x-mean_cos_u).^2/2/var_cos_u);
norm_dis_cos_r = 1/sqrt(2*pi*var_cos_r)*exp(-(norm_x-mean_cos_r).^2/2/var_cos_r);

 
% figure
% bar(bins_cos_u,hist_cos_u)
% figure
% bar(bins_cos_u,hist_cos_r)

delta_pres_cos = bins_delta_cos_u/4;

figb = figure;
bar(bins_cos_u+bins_delta_cos_u/2-delta_pres_cos,hist_cos_u,0.5,'EdgeColor','none')
hold on
bar(bins_cos_r+bins_delta_cos_r/2+delta_pres_cos,hist_cos_r,0.5,'r','EdgeColor','none')
plot(norm_x,norm_dis_cos_u,'k','LineWidth',3)
plot(norm_x,norm_dis_cos_r,'k','LineWidth',3)
set(gca, 'TickLength', [0.03 0.025])

 xlim([-4 4]);

% title('Fourier coefficients in spiking response')
% xlabel('Re of c_R and c_{R|S}')
% ylabel('Probability density')

% savefig(figb,'Figure_Supplement_b.fig')

%% Plotting abs

var_abs_u  = (var_cos_u+var_sin_u)/2;
var_abs_r  = (var_cos_r+var_sin_r)/2;

bins_min = 0;
bins_max = 4;
bins_count = 30;
bins_abs = linspace(bins_min,bins_max,bins_count);
bins_delta_abs = bins_abs(2)-bins_abs(1);

hist_abs_u = histc(coef_abs_u,bins_abs)/coef_count/bins_delta_abs;
hist_abs_r = histc(coef_abs_r,bins_abs)/coef_count/bins_delta_abs;


ray_x_count = 10000;
ray_x = linspace(0,bins_max,ray_x_count);

ray_dis_u = ray_x/var_abs_u.*exp(-ray_x.^2/2/var_abs_u);
ray_dis_r = ray_x/var_abs_r.*exp(-ray_x.^2/2/var_abs_r);


delta_pres_abs = bins_delta_abs/4;


figc = figure;
bar(bins_abs+bins_delta_abs/2-delta_pres_abs,hist_abs_u,0.5,'EdgeColor','none')
hold on
bar(bins_abs+bins_delta_abs/2+delta_pres_abs,hist_abs_r,0.5,'r','EdgeColor','none')
plot(ray_x,ray_dis_u,'k','LineWidth',3)
plot(ray_x,ray_dis_r,'k','LineWidth',3)
set(gca, 'TickLength', [0.03 0.025])

 xlim([0 4]);

% title('Amplitudes are Rayleigh-distributed')
% xlabel('Amplitudes of c_R and c_{R|s}')
% ylabel('Probability density')


% savefig(figc,'Figure_Supplement_c.fig')

%% Plotting angle
bins_min = -pi;
bins_max =  pi;
bins_count = 20;
bins_angle = linspace(bins_min,bins_max,bins_count);
bins_delta_angle = bins_angle(2)-bins_angle(1);

hist_angle_u = histc(coef_angle_u,bins_angle)/coef_count/bins_delta_angle;
hist_angle_r = histc(coef_angle_r,bins_angle)/coef_count/bins_delta_angle;


delta_pres_angle = bins_delta_angle/4;

figd = figure;

bar(bins_angle+bins_delta_angle/2-delta_pres_angle,hist_angle_u,0.5,'EdgeColor','none');
hold on
bar(bins_angle+bins_delta_angle/2+delta_pres_angle,hist_angle_r,0.5,'r','EdgeColor','none');
line([-pi pi], [1/2/pi 1/2/pi],'LineWidth',3,'Color',[0 0 0])
xlim([-pi pi]);
set(gca, 'XTick', [-pi 0 pi])
set(gca, 'YTick', [0 1/2/pi])
set(gca, 'TickLength', [0.03 0.025])

title('Phases are uniformly distributed')
xlabel('Phase of A_R and A_{R|s}')
ylabel('Probability density')

% savefig(figd,'Figure_Supplement_d.fig')
