
%% Properties


plot_freq_start = 1; % Hz
plot_freq_end =   500; % Hz

plot_freq_difference = 1; % ms


%% Readin Data

tic_start = tic;


dir_data = [dir_name, 'Input_Switch10Hz'];

cd(dir_data);

 load('params.mat','T_seq_korrigiert','Ntr')
%% Specify Frequencies

freqs_deltaf = 1/T_seq_korrigiert*1000;

freqs1 = ceil(plot_freq_start/freqs_deltaf)*freqs_deltaf:freqs_deltaf:plot_freq_end;
freqs2 = (ceil(plot_freq_start/freqs_deltaf)+ceil(plot_freq_difference/freqs_deltaf))*freqs_deltaf:freqs_deltaf:(plot_freq_end+plot_freq_difference);



%% Uniques
 load('data.mat','t_s_u')
t_s = t_s_u;
% clear t_s_u;
if length(freqs1)< length(freqs2)
 Cov_coef_u = zeros(size(freqs1));
 freqs=freqs1;
else
Cov_coef_u = zeros(size(freqs2));
freqs=freqs2;
end

tic
parfor xx = 1:length(freqs)

freq1 = freqs1(xx);
freq2 = freqs2(xx);
    
    
%% Calculate sine and cosine coefficients




coef1_cos_u = zeros(Ntr,1);
coef2_cos_u = zeros(Ntr,1);


for i = 1 : Ntr 
spike_train = t_s{1,i};
    
    
   coef1_cos_u(i,1)     = 1000*2/T_seq_korrigiert*sum(cos(2*pi*freq1*spike_train/1000),2)';
   coef2_cos_u(i,1)     = 1000*2/T_seq_korrigiert*sum(cos(2*pi*freq2*spike_train/1000),2)';

end




%% Further calculation

var1_cos_u = var(coef1_cos_u(:,1));
var2_cos_u = var(coef2_cos_u(:,1));

% mean1_cos_u = mean(coef1_cos_u(:,1));
% mean2_cos_u = mean(coef2_cos_u(:,1));


Cov = cov([coef1_cos_u coef2_cos_u])/sqrt(var1_cos_u)/sqrt(var2_cos_u);
Cov_coef_u(xx) = Cov(2);
end
toc

%% Repeats
 load('data.mat','t_s_r')
t_s = t_s_r;
% clear t_s_r;
if length(freqs1)< length(freqs2)
 Cov_coef_r = zeros(size(freqs1));
 freqs=freqs1;
else
Cov_coef_r = zeros(size(freqs2));
freqs=freqs2;
end

tic
parfor xx = 1:length(freqs)

freq1 = freqs1(xx);
freq2 = freqs2(xx);
    
    
%% Calculate sine and cosine coefficients




coef1_cos_r = zeros(Ntr,1);
coef2_cos_r = zeros(Ntr,1);


for i = 1 : Ntr 
spike_train = t_s{1,i};
    
    
   coef1_cos_r(i,1)     = 1000*2/T_seq_korrigiert*sum(cos(2*pi*freq1*spike_train/1000),2)';
   coef2_cos_r(i,1)     = 1000*2/T_seq_korrigiert*sum(cos(2*pi*freq2*spike_train/1000),2)';

end




%% Further calculation

var1_cos_r = var(coef1_cos_r(:,1));
var2_cos_r = var(coef2_cos_r(:,1));

% mean1_cos_u = mean(coef1_cos_u(:,1));
% mean2_cos_u = mean(coef2_cos_u(:,1));


Cov = cov([coef1_cos_r coef2_cos_r])/sqrt(var1_cos_r)/sqrt(var2_cos_r);
Cov_coef_r(xx) = Cov(2);
end
toc


%% Plot

mean_cov_u = mean(Cov_coef_u);
mean_cov_r = mean(Cov_coef_r);

var_cov_u = var(Cov_coef_u);
var_cov_r = var(Cov_coef_r);

bins_cov_min = -0.5;
bins_cov_max =  0.5;
bins_cov_count = 60;
bins_cov = linspace(bins_cov_min,bins_cov_max,bins_cov_count);
bins_cov_delta = bins_cov(2)-bins_cov(1);

delta_pres_cov = bins_cov_delta/4;

coef_count = length(Cov_coef_u);

hist_cov_u = histc(Cov_coef_u,bins_cov)/coef_count/bins_cov_delta;
hist_cov_r = histc(Cov_coef_r,bins_cov)/coef_count/bins_cov_delta;

fig = figure;
bar(bins_cov+bins_cov_delta/2-delta_pres_cov,hist_cov_u,0.5,'EdgeColor','none');
hold on
bar(bins_cov+bins_cov_delta/2+delta_pres_cov,hist_cov_r,0.5,'r','EdgeColor','none');
set(gca, 'TickLength', [0.03 0.025])
xlim([-0.4 0.4])


title('Lack of correlation across frequencies')
xlabel('Correlation coefficient')
ylabel('Probability density')
