dir_name = [dir_return,'/Simulation_Data/'];



% 1 LIF with reset


%% Reset is on
reset=1;

    



%% Parameter
% Number of Stimuli
N = 1;

% Trial count
Ntr = 10000;

% Time-vector:
T_start = 0; % (ms)

T_sequence = 40000; % (ms)


display(strcat(['T_seq = ', num2str(T_sequence), ' !']));

%% Assigning timestep size, stimestep count and time vector

dt = 0.1; 
sqrt_dt = sqrt(dt);
  steps = ceil(T_sequence/dt);

T_SteadyState=0;
t = zeros(1,steps);

for i = 1:steps
t(i) = T_start+i*dt;
end



% OU-Process:
ou_Tau_cor  =10;
ou_diffu_const = 1; 
ou_sigma = 1.46;
ou_mean  = 0;

ou_cor_n =     0;  % No noise correlation, noise is always drawn randomly
ou_cor_c =     0; % Independent stimuli for signal entropy trials
ou_cor_r =     0.6;  % Cross trial correlation for repeated stimuli


%% Bimodal input

snr = ou_cor_r;
amp_cos_signal = 12.5;
amp_cos_noise  = 12.5;
switch_rate_Hz = 10; % [Hz]
switch_prob = switch_rate_Hz/1000*dt;
delta_tp=0.02*1000; % 0.02 seconds correspond to 50 Hz



phi_max =  pi;
phi_min = -pi;



% Leaky Integragtor:
LI_Tau_mem =25;%11.4; % Membrane time constant (ms)
LI_equi    = 0;    % Equilibrium potential (ms)
LI_R       = 1;    % Resistance for Input stimulus 
ST_threshold = 1; 

LI_V_reset=-1;
%% Analytic Firing Rate
FiR_analytic = 1/(2*pi*sqrt(ou_Tau_cor*LI_Tau_mem))*exp(-((ST_threshold)^2)...
              /(2*((ou_sigma^2)*ou_Tau_cor^2/(2*(ou_Tau_cor+LI_Tau_mem)))));

%% Starting values;
%OU-Process:
ou_start = 0;
% Leaky Integrator:
LI_V_start = LI_equi; % Setting equilibrium as start







%% Assign Help functions

%Decays for OU and LI process
ou_decay = exp(-dt/ou_Tau_cor);
LI_decay = exp(-dt/LI_Tau_mem);





%% Assign Vectors
% Spike times uniques
 t_s_u       = cell(N,1);
for n = 1:N
  t_s_u{n} = cell(Ntr,1);
end
 
 % Spike times repeats
 t_s_r       = cell(N,1);
for n = 1:N
  t_s_r{n} = cell(Ntr,1);
end




%% Calculating processes for repeats and setting random numbers in general
stream_uncommon_seed = 4;
stream_uncommon = RandStream('mrg32k3a','Seed',stream_uncommon_seed);
stream_uncommon_state = stream_uncommon.State;

stream_common_seed = 4;
stream_common = RandStream('mt19937ar','Seed',stream_common_seed); 
stream_common_state = stream_common.State;


%% Calculation
tic_calculation = tic;
for n = 1:N
tic_n = tic;
 % Assign Starting values
    ou_signal_tn = ones(1,Ntr)*ou_start;
    ou_noise_tn  = ones(1,Ntr)*ou_start;
    ou_signal_n  =             ou_start;
   
    
    LI_V_u  = ones(1,Ntr)*LI_V_start;
    LI_V_r  = ones(1,Ntr)*LI_V_start;
    
    ou_yes_signal_u = false(1,Ntr);
    ou_yes_signal_r = false(1,1);
    ou_yes_noise    = false(1,Ntr);
    
    input_signal_u = zeros(1,Ntr);
    input_signal_r = zeros(1,1);
    input_noise = zeros(1,Ntr);
    
 % Assign RandomStreams
    %Uniques
    set(stream_uncommon,'Substream',n);
    %Repeats
    stream_common = RandStream('mt19937ar','Seed',0);
    stream_common.State = stream_common_state;
    
    
    delta_phi_signal_u = zeros(1,Ntr);
    delta_phi_signal_r = zeros(1,1);
    delta_phi_noise    = zeros(1,Ntr);
 
 t_time = 0;
 for k = 1:steps

     
     t_time = t_time+dt;
     
%% Switching

    switch2p_signal_u = false(1,Ntr);
    switch2p_signal_r = false(1,1);
    switch2p_noise    = false(1,Ntr);

    switchyn_signal_u = (rand(stream_uncommon,1,Ntr)<switch_prob);
    switchyn_signal_r = (rand(stream_uncommon,1,1)  <switch_prob);
    switchyn_noise    = (rand(stream_uncommon,1,Ntr)<switch_prob);
    
    switch2p_signal_u(ou_yes_signal_u) = switchyn_signal_u(ou_yes_signal_u);
    switch2p_signal_r(ou_yes_signal_r) = switchyn_signal_r(ou_yes_signal_r);
    switch2p_noise(ou_yes_noise)       = switchyn_noise(ou_yes_noise);
    
    ou_yes_signal_u(switchyn_signal_u) = ~ou_yes_signal_u(switchyn_signal_u);
    ou_yes_signal_r(switchyn_signal_r) = ~ou_yes_signal_r(switchyn_signal_r);
    ou_yes_noise(switchyn_noise)       = ~ou_yes_noise(switchyn_noise);
    

%% Uniques Signal
  
    
    % OU-Processes
    gauss_signal_tn = randn(stream_uncommon, 1,sum(ou_yes_signal_u));
       ou_signal_tn(ou_yes_signal_u) = ou_signal_tn(ou_yes_signal_u)*ou_decay+ou_mean*(1-ou_decay)+...
               ou_sigma*sqrt((ou_Tau_cor/2)*(1-ou_decay^2))*gauss_signal_tn;          
                      
           
    input_signal_u(ou_yes_signal_u) =  ou_signal_tn(ou_yes_signal_u);
    
    
        
    % Periodic Sinusoid
    delta_phi_signal_u(switch2p_signal_u) = phi_min+(phi_max-phi_min)*rand(stream_uncommon,1,sum(switch2p_signal_u));
    
    phi = 2*pi/delta_tp*t_time;
    input_signal_u(~ou_yes_signal_u) = amp_cos_signal*cos(phi + delta_phi_signal_u(~ou_yes_signal_u)); 

   

%% Repeats Signal    

    if(ou_yes_signal_r)
    
    % OU-Processes
           
    gauss_signal_n  = randn(stream_uncommon, 1,1);
       ou_signal_n  = ou_signal_n*ou_decay+ou_mean*(1-ou_decay)+...
               ou_sigma*sqrt((ou_Tau_cor/2)*(1-ou_decay^2))*gauss_signal_n;
             
           
    input_signal_r = repmat(ou_signal_n,1,Ntr) ;
    
    else
    
    % Periodic Sinusoid
    delta_phi_signal_r(switch2p_signal_r) = phi_min+(phi_max-phi_min)*rand(stream_uncommon,1,sum(switch2p_signal_r));
    
    phi = 2*pi/delta_tp*t_time;
    input_signal_r = amp_cos_signal*cos(phi + delta_phi_signal_r);
    input_signal_r = repmat(input_signal_r,1,Ntr);

    end
    
    
   
    
    % OU-Processes
    gauss_noise_tn = randn(stream_uncommon, 1,sum(ou_yes_noise));
       ou_noise_tn(ou_yes_noise) = ou_noise_tn(ou_yes_noise)*ou_decay+ou_mean*(1-ou_decay)+...
               ou_sigma*sqrt((ou_Tau_cor/2)*(1-ou_decay^2))*gauss_noise_tn;          
                      
           
    input_noise(ou_yes_noise) =  ou_noise_tn(ou_yes_noise);
    
  
        
    % Periodic Sinusoid
    delta_phi_noise(switch2p_noise) = phi_min+(phi_max-phi_min)*rand(stream_uncommon,1,sum(switch2p_noise));
    
    phi = 2*pi/delta_tp*t_time;
    input_noise(~ou_yes_noise) = amp_cos_noise*cos(phi + delta_phi_noise(~ou_yes_noise)); 

     
    
    
    % Leaky integrate
                
        LI_V_u = LI_V_u*LI_decay+(1-LI_decay)*(LI_equi+LI_R*(sqrt(snr)*input_signal_u+sqrt(1-snr)*input_noise));
                
        LI_V_r = LI_V_r*LI_decay+(1-LI_decay)*(LI_equi+LI_R*(sqrt(snr)*input_signal_r+sqrt(1-snr)*input_noise));
              



   % Spikes Uniques
   spike_yn_u    = (LI_V_u>=ST_threshold);
   index         = find(spike_yn_u);
   
   if reset==1
   % Reset
   LI_V_u(index) = LI_V_reset; 
    
   end

 if(t_time >= T_SteadyState)
  for i = index
   t_s_u{n}{i} = [t_s_u{n}{i} (t_time-T_SteadyState)]; 
  end
 end
   
   
      % Spikes Repeats
   spike_yn_r = (LI_V_r>=ST_threshold);
   index = find(spike_yn_r);
   
   if reset==1
   % Reset
   LI_V_r(index) = LI_V_reset;
   end 
   
 if(t_time >= T_SteadyState)  
  for i = index
   t_s_r{n}{i} = [t_s_r{n}{i} (t_time-T_SteadyState)]; 
  end
 end 



 end
 
disp(strcat(['Stimulus ', num2str(n),' of ', num2str(N),' done. Time was ',num2str(toc(tic_n)), ' seconds.']));  
 
end



%% Changing order of trials and neurons in the t_s-cells


Spike_count_u = zeros(N,Ntr);
Spike_count_r = zeros(N,Ntr);

for j = 1:N
    for i = 1:Ntr
        Spike_count_u(j,i) = length(t_s_u{j}{i});
        Spike_count_r(j,i) = length(t_s_r{j}{i});
    end
end

Spike_count_0_u = Spike_count_u == 0;
Spike_count_0_r = Spike_count_r == 0;

disp(['UN: There are ', num2str(sum(sum(Spike_count_0_u,2),1)), ' Trials in with 0 Spike count.'])
disp(['UN: That is ', num2str(sum(sum(Spike_count_0_u,2),1)/Ntr/N*100), ' % of all Trials.'])

disp(['RE: There are ', num2str(sum(sum(Spike_count_0_r,2),1)), ' Trials in with 0 Spike count.'])
disp(['RE: That is ', num2str(sum(sum(Spike_count_0_r,2),1)/Ntr/N*100), ' % of all Trials.'])
 % Reordering the cell structure
 t_s_u_new       = cell(N,Ntr);
 t_s_r_new       = cell(N,Ntr);

 % Matrix for first spike only
 t_s_fs_matrix_u = zeros(N,Ntr);
 t_s_fs_matrix_r = zeros(N,Ntr);
 
for j = 1:N
for i = 1:Ntr
  t_s_u_new{j,i} = t_s_u{j}{i};
  t_s_r_new{j,i} = t_s_r{j}{i};
  
  
  if(Spike_count_u(j,i) >= 1)
  t_s_fs_matrix_u(j,i) = t_s_u{j}{i}(1);
  else
  t_s_fs_matrix_u(j,i) = 0;  
  end
  
  if(Spike_count_r(j,i) >= 1)
  t_s_fs_matrix_r(j,i) = t_s_r{j}{i}(1);
  else
  t_s_fs_matrix_r(j,i) = 0;     
  end
  
end
end

  t_s_u = t_s_u_new;
  t_s_r = t_s_r_new;
  
  clear t_s_u_new t_s_r_new


%% Calculating Firing Rates

T_seq_korrigiert = T_sequence-T_SteadyState;


% FiR for all spikes
FiR_u = Spike_count_u/T_seq_korrigiert*1000;
FiR_r = Spike_count_r/T_seq_korrigiert*1000;

FiR_tr_mean_u = mean(FiR_u,2);
FiR_tr_mean_r = mean(FiR_r,2);

FiR_mean_u = mean(FiR_tr_mean_u);
FiR_mean_r = mean(FiR_tr_mean_r);

% FiR for First-Spike-Matrix
T_fs_tr_mean_u = mean(t_s_fs_matrix_u,2);
T_fs_tr_mean_r = mean(t_s_fs_matrix_r,2);

FiR_fs_tr_mean_u = 1./T_fs_tr_mean_u*1000;
FiR_fs_tr_mean_r = 1./T_fs_tr_mean_r*1000;

T_fs_mean_u = mean(T_fs_tr_mean_u,1);
T_fs_mean_r = mean(T_fs_tr_mean_r,1);

FiR_fs_mean_u = 1./T_fs_mean_u*1000;
FiR_fs_mean_r = 1./T_fs_mean_r*1000;






%% Save


R = dir(dir_name);
if (isempty(R))
    mkdir(dir_name);
    R = dir(dir_name);
end
folder_count = length(R)-1;
folder_name = [dir_name 'Input_Switch10Hz'];

mkdir(folder_name);
cd(folder_name);

clear R folder_count folder_name 

save('params.mat','stream*', ...
     'Ntr', 'N','t','T_*', 'LI_*', 'ST*', 'dt');

save('data.mat','t_s_*', 'FiR_*','-v7.3');

